

Sub Access20Error (AccessError As Integer)
      Select Case AccessError
        Case 1010
            msg$ = "Invalid database ID."
        
        Case 1016
            msg$ = "Can't have more than 10 fields in an index."
        
        Case 1029
            msg$ = "Database engine hasn't been initialized."
        
        Case 1030
            msg$ = "Database engine has already been initialized."
        
        Case 1034
            msg$ = "Query support unavailable."
        
        Case 1046
            msg$ = "Can't delete a field that is part of an index."
        
        Case 1051
            msg$ = "Can't delete this index.  It is either the current index  or is used in a relationship."
        
        Case 1062
            msg$ = "Can't create database; Invalid locale."
        
        Case 1066
            msg$ = "Can't create a relationship."
        
        Case 1068
            msg$ = "Invalid referential integrity constraint."
        
        Case 1209
            msg$ = "The Jet database engine has encountered a problem in your database.  To correct the problem, you must repair and compact the database."
        
        Case 1308
            msg$ = "Can't define field or index in a table that contains data."
        
        Case 1309
            msg$ = "Can't modify table structure.  Another user has the table  open."
        
        Case 1315
            msg$ = "Can't change a rule while the rules for this table are in use."
        
        Case 1316
            msg$ = "Object is invalid for operation."
        
        Case 1402
            msg$ = "Primary key already exists."
        
        Case 1403
            msg$ = "Index already exists."
        
        Case 1406
            msg$ = "Invalid index definition."
        
        Case 1513
            msg$ = "Can't create index on Memo field or OLE Object field."
        
        Case 1519
            msg$ = "Can't delete this field.  It's part of one or more  relationships."
        
        Case 1523
            msg$ = "Zero length string is valid only in a text or Memo field."
        
        Case 1802
            msg$ = "Can't open system database (typically SYSTEM.MDA)."
        
        Case 1910
            msg$ = "You must enter a personal identifier (PID) consisting of  at least four and no more than 20 characters and digits."
        
        Case 1911
            msg$ = "Account name already exists."
        
        Case 2030
            msg$ = "There are several tables with that name. Please specify  owner in the format 'owner.table'."
        
        Case 2031
            msg$ = "Invalid connection string in pass through query."
        
        Case 2032
            msg$ = " Single row update/delete affected more than one row of a  remote table.  Index specified as unique contains duplicate values."
        
        Case 2033
            msg$ = "The server's MSysConf table exists, but is in an incorrect format.  Contact your system administrator."
        
        Case 2034
            msg$ = "You cannot use ODBC to attach an external Microsoft  Access or ISAM database table to your  database."
        
        Case 3028
            msg$ = "Can't have action query as an input."
        
        Case 3031
            msg$ = "Query does not return records."
        
        Case 3059
            msg$ = "This query is not a properly formed data definition  query."
        
        Case 3060
            msg$ = "No database specified in connection string or IN clause."
        
        Case 3063
        
            msg$ = "At most one field can be returned from a subquery that doesn't use the EXISTS keyword."
        
        Case 3064
            msg$ = "The number of columns in the two selected tables or queries of a union query don't match."
        
        Case 3066
            msg$ = "Execute method must be used on action or data definition queries."
        
        Case 3069
            msg$ = "Pass through query with ReturnsRecords property set to True did not return any records."
        
        Case 3070
            msg$ = "At most one record can be returned by this subquery."
        
        Case 3071
            msg$ = "Query is too complex."
        
        Case 3072
            msg$ = "Unions not allowed in a subquery."
        
        Case 3073
            msg$ = "Can't perform join, group, or sort. Combined fields are too long."
        
        Case 3077
            msg$ = "Too many FastFind Sessions were invoked."
        
        Case 3520
            msg$ = "Number  of query values and destination fields aren't the same."
        
        Case 3530
            msg$ = "Join expression not supported."
        
        Case 3531
            msg$ = "Can be present only in version 1.0 format."
        
        Case 3532
            msg$ = "Syntax error in union query."
        
        Case 3535
            msg$ = "Pass through query must contain at least one character."
        
        Case 3550
            msg$ = "Syntax error in CONSTRAINT clause."
        
        Case 3551
            msg$ = "Syntax error in CREATE TABLE statement."
        
        Case 3552
            msg$ = "Syntax error in CREATE INDEX statement."
        
        Case 3553
            msg$ = "Syntax error in field definition."
        
        Case 3554
            msg$ = "Syntax error in ALTER TABLE statement."
        
        Case 3555
            msg$ = "Syntax error in DROP INDEX statement."
        
        Case 3556
            msg$ = "Syntax error in DROP TABLE statement."
        
        Case 3560
            msg$ = "Relationship must be on the same number of fields with the same data types."
        
        Case 3561
            msg$ = "Can't find field in index definition."
        
        Case 3601
            msg$ = "Property setting can't be larger than 2 KB."
        
        Case 3602
            msg$ = "This property isn't supported for external data sources or for databases created in a previous version."
        
        Case 3603
            msg$ = "Property specified already exists."
        
        Case 3604
            msg$ = "DeleteOnly called with non zero cbData."
        
        Case 3605
            msg$ = "An error has occurred.  Properties were not saved."
        
        Case 3606
            msg$ = "Can't save property; property is a schema property."
        
        Case 3700
            msg$ = "Validation rules and default values can't be placed on system or attached tables."
        
        Case 3704
            msg$ = "Can't place this validation expression on this field."
        
        Case 3708
            msg$ = "Syntax error in default value."
        
        Case 5015
            msg$ = "External table isn't in the expected format."
        
        Case 5016
            msg$ = "Unexpected error from external database driver."
        
        Case 5017
            msg$ = "Numeric field overflow."
        
        Case 5020
            msg$ = "Paradox index is not primary."
        
        Case 5029
            msg$ = "Can't open.  Another user has the table open using a different network control file or locking style."
        
        Case 5030
            msg$ = "Can't open this Paradox 4.x table because ParadoxNetStyle is set to 3.x."
        
        Case 5112
            msg$ = "Format of memo file doesn't match specified external database format."
        
        Case 5210
            msg$ = "Btrieve: Invalid IndexDDF option ."
        
        Case 5211
            msg$ = "Invalid DataCodePage option ."
        
        Case 5212
            msg$ = "Btrieve: Xtrieve options aren't correct in ."
        
        Case 5213
            msg$ = "Btrieve: Can't find file FIELD.DDF."
        
        Case 5214
            msg$ = "Btrieve: Invalid IndexDeleteRenumber option."
        
        Case 8056
            msg$ = "No destination field name in INSERT statement."
        
        Case 8172
            msg$ = "Top not allowed in delete queries."
        
        Case 8175
            msg$ = "Crosstab query contains one or more invalid fixed column headings."
        
        Case 8176
            msg$ = "Query is corrupt."
        
        Case 8177
            msg$ = "Invalid TOP argument in select query."
        
        Case 8178
            msg$ = "This Recordset is not updatable."
        
        Case 8179
            msg$ = "Field is based on an expression and can't be edited."
        
        Case 8180
            msg$ = "Table  is read only."
        
        Case 8181
            msg$ = "Record in table  was deleted by another user."
        
        Case 8182
            msg$ = "Record in table is locked by another user."
        
        Case 8183
            msg$ = "To make changes to this field, first save the record."
        
        Case 8184
            msg$ = "Can't enter value into blank field on 'one' side of outer  join."
        
        Case 8185
            msg$ = "Records in table would have no record on the 'one'  side."
        
        Case 8186
            msg$ = "Current field must match join key on 'one' side of outer join."
        
        Case 8187
            msg$ = "Invalid Memo or OLE object in subquery."
        
        Case 8188
            msg$ = "Unrecognized database format."
        
        Case 8189
            msg$ = "ORDER BY expression uses non output fields."
        
        Case 8190
            msg$ = "Unknown or invalid reference  in validation expression or default value in table."
        
        Case 8191
            msg$ = "Unknown or invalid field reference."
        
        Case 8192
            msg$ = "Can't add record(s); primary key for table not in recordset."
        
        Case 8193
            msg$ = "Can't add record(s); join key of table not in recordset."
        
        Case 8194
            msg$ = "The database is opened by user on machine.  You can't open this database exclusively."
        
        Case 8195
            msg$ = "Record(s) can't be added; no corresponding record on the 'one' side."
        
        Case 8196
            msg$ = "Can't use Memo or OLE object field   in SELECT clause of a union query."
        
        Case 8197
            msg$ = "Unknown function   in validation expression or default value on."
        
        Case 8220
            msg$ = "Can't modify the design of table.  It's in a read only database."
        
        Case 8221
            msg$ = "Can't find table or constraint."
        
        Case 8222
            msg$ = "No such index  on table."
        
        Case 8223
            msg$ = "Can't create relationship.  Referenced table doesn't have a primary key."
        
        Case 8224
            msg$ = "The specified fields are not uniquely indexed in table."
        
        Case 8225
            msg$ = "Table  already has an index named."
        
        Case 8226
            msg$ = "Table doesn't exist."
        
        Case 8227
            msg$ = "No such relationship on table ."
        
        Case 8228
            msg$ = "There is already a relationship named  in the current  database."
        
        Case 8229
            msg$ = "Can't create relationships to enforce referential integrity.  Existing data in table  violates referential integrity rules with related table."
        
        Case 8230
            msg$ = "Field already exists in table."
        
        Case 8231
            msg$ = "There is no field named in table ."
        
        Case 8232
            msg$ = "Field   size must be 1 to 255."
        
        Case 8233
            msg$ = "Can't delete field.  It's part of one or more relationships."
        
        Case 8234
            msg$ = "There is no primary key in table ."
        
        Case 8235
            msg$ = "Invalid field name  in definition of index or relationship."
        
        Case 8260
            msg$ = "Error in table level validation expression."
        
        Case 8261
            msg$ = "Field  can't contain a null value."
        
        Case 8262
            msg$ = "Field can't be a zero length string."
        
        Case 8263
            msg$ = "This validation rule must be met."
        
        Case 8264
            msg$ = "Can't perform cascading operation.  Since related records exist in table , referential integrity rules would be violated."
        
        Case 8265
            msg$ = "Can't perform cascading operation.  There must be a related record in table ."
        
        Case 8266
            msg$ = "Can't perform cascading operation.  It would result in a null key in table."
        
        Case 8267
            msg$ = "Can't perform cascading operation.  It would result in a duplicate key in table ."
        
        Case 8268
            msg$ = "Can't perform cascading operation.  It would result in two updates on field  in table ."
            
        Case 8269
            msg$ = "Can't perform cascading operation.  It would cause field  to become null, which is not allowed."
        
        Case 8270
            msg$ = "Can't perform cascading operation.  It would cause field to become a zero length string, which is not allowed."
        
        Case 8271
            msg$ = "Can't perform cascading operation:"
        
        Case 8272
            msg$ = "Invalid entry.  Can't perform cascading operation specified in table  because value entered is too big  for field ."
        
        Case 8273
            msg$ = "There is no message for this error."
        
        Case 8274
            msg$ = "Can't perform cascading update on table because it  currently in use."
        
        Case 20000
            msg$ = "Can't open this database for update."
        
        Case 30001
            msg$ = "No fields defined   cannot append table."
        
        Case 30002
            msg$ = "Name not found in this collection."
        
        Case 30003
            msg$ = "Can't append.  Field is part of a TableDefs collection."
        
        Case 30004
            msg$ = "Property can be set only when the field is part of a Recordset object's Fields collection."
        
        Case 30005
            msg$ = "Can't set this property once the object is part of a collection."
        
        Case 30006
            msg$ = "Can't append.  Index is part of a TableDefs collection."
        
        Case 30007
            msg$ = "Property not found."
        
        Case 30008
            msg$ = " Invalid property value."
        
        Case 30009
            msg$ = "Object isn't a collection."
        
        Case 30010
            msg$ = "Method not applicable for this object."
        
        Case 30011
            msg$ = "Can't set this property for remote objects."
        
        Case 30012
            msg$ = "Can't append a relation with no fields defined."
        
        Case 30013
            msg$ = "Can't append.  Object already in collection."
        
        Case 30014
            msg$ = "Can't delete a built in property."
        
        Case 30015
            msg$ = "Property  must be set before using this method."
        
        Case 30016
            msg$ = "User defined properties don't support a Null value."
        
        Case 30017
            msg$ = "Object is no longer valid."
        
        Case 30018
            msg$ = "This method or property is not currently available on this Recordset."
        
        Case 30019
            msg$ = "The action was canceled by an associated object."
        
        Case 30020
            msg$ = "Error in DAO automation."
        
        Case 30021
            msg$ = "Data type conversion error."
        
        Case 32020
            msg$ = "Can't import table or query.  No records found, or all records contain errors."
        
        End Select
        MsgBox msg$

End Sub

